﻿#include <thread>
#include <mutex>
#include <iostream>
#include <string>

int main() {
    std::mutex m;

    auto thread_func = [&m](std::string s) {
        for (int i = 0; i < 10'000; ++i) {
            std::unique_lock<std::mutex> l(m);
            std::cout << "Ahoj " << s << "! Jak se mas?\n";
        }
    };

    std::thread t1(thread_func, "XXXXX");
    std::thread t2(thread_func, "OOOOO");

    t1.join();
    t2.join();
}
